#include <iostream>

class VirtualBase {
public:
  virtual ~VirtualBase() {}
  virtual void setValue(int i) = 0;
  virtual int getValue(void) = 0;
};

class Derived : public virtual VirtualBase {
public:
  ~Derived() { }
  void setValue(int i) {
    theValue = i;
  } 
  int getValue(void) {
    return theValue;
  }
  void printValue(void) {
    using namespace std;
    cout << "Derived::printValue(): value is " << theValue << endl;
  }
private:
  int theValue;
};

void printTheValue1(VirtualBase* v) {
  using namespace std;
  cout << "printTheValue1(): value is " << v->getValue() << endl;
}

void printTheValue2(VirtualBase* v) {
  Derived* d = dynamic_cast<Derived*>(v);
  d->printValue();
}

int main(int argc, char** argv) {
  int ret = 0;
  Derived d;
  VirtualBase* v = &d;
  v->setValue(1); // same as (*v).setValue(1);
  printTheValue1(v);
  printTheValue2(v);
  return ret;
}
